> ## Documentation Index
> Fetch the complete documentation index at: https://docs.notifly.tech/llms.txt
> Use this file to discover all available pages before exploring further.

# Send a free-form Kakao Brand Message

> Send a message without a template.

> [!WARNING]
>
> * All recipients in a request receive the same message content.
> * If the message type requires an image, call [Upload a Brand Message image](https://docs.notifly.tech/en/api-reference/upload-kakao-brand-message-image.md) first. Use the returned `data.images[].url` value.
> * For `PREMIUM_VIDEO`, set `videoUrl` to the delivery URL that Kakao BizMessage's video upload API returns after registration and encoding. A general video URL or a KakaoTV page URL does not work. Notifly currently has no public video upload API. If you need video upload, contact [contact@notifly.tech](mailto:contact@notifly.tech).
> * Free-form messages support `M`, `N`, and `I` audiences. They do not support `I+N`.
> * The endpoint supports channels that use the `Notifly` KakaoTalk delivery platform. Channels using `Notifly (Legacy)` cannot use this endpoint.


## OpenAPI

````yaml /en/api-reference/openapi.yaml post /messages/kakao-brand-message/freestyle
openapi: 3.0.3
info:
  title: Notifly API
  version: 1.0.0
  contact:
    email: contact@notifly.tech
servers:
  - url: https://api.notifly.tech
    description: Notifly API server
security: []
tags:
  - name: catalog
    x-group: Catalogs
paths:
  /messages/kakao-brand-message/freestyle:
    post:
      summary: send-kakao-brand-message-freestyle
      operationId: sendKakaoBrandMessageFreestyle
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequest'
            examples:
              image:
                summary: Free-form image message
                value:
                  projectId: example_project_1234567890abcdef
                  channelId: your-kakao-channel-id
                  target: M
                  chatBubbleType: IMAGE
                  message: 새로운 라이브 상품이 등록되었습니다.
                  attachment:
                    image:
                      imgUrl: https://mud-kage.kakao.com/example/image.jpg
                      imgLink: https://example.com/products/123
                  recipientList:
                    - recipientNo: '01012345678'
              carouselCommerce:
                summary: Free-form carousel commerce message
                value:
                  projectId: example_project_1234567890abcdef
                  channelId: your-kakao-channel-id
                  target: M
                  chatBubbleType: CAROUSEL_COMMERCE
                  carousel:
                    list:
                      - additionalContent: 오늘만 할인
                        attachment:
                          image:
                            imgUrl: https://mud-kage.kakao.com/example/product-1.jpg
                            imgLink: https://example.com/products/1
                          commerce:
                            title: 첫 번째 상품
                            regularPrice: 10000
                            discountPrice: 8000
                            discountRate: 20
                          button:
                            - name: 구매하기
                              type: WL
                              urlMobile: https://example.com/products/1
                      - attachment:
                          image:
                            imgUrl: https://mud-kage.kakao.com/example/product-2.jpg
                            imgLink: https://example.com/products/2
                          commerce:
                            title: 두 번째 상품
                            regularPrice: 20000
                          button:
                            - name: 구매하기
                              type: WL
                              urlMobile: https://example.com/products/2
                  recipientList:
                    - recipientNo: '01012345678'
      responses:
        '200':
          description: >-
            The send request was queued. This response only confirms queue
            acceptance.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleSuccessResponse'
              example:
                success: true
        '400':
          description: >-
            The request is invalid, or sender information for the specified
            `channelId` is missing.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleErrorResponse'
              example:
                success: false
                error: Sender info is not registered.
        '401':
          description: The authentication token is missing or invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleErrorResponse'
              example:
                success: false
                error: Invalid Authorization Token
        '413':
          description: The request has more than 1,000 recipients.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleErrorResponse'
              example:
                success: false
                error: >-
                  Payload Too Large. Can accept up to 1000 recipients per
                  request.
        '500':
          description: >-
            A server error occurred while looking up the sender, preparing
            message data, or queuing the request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleErrorResponse'
              example:
                success: false
                error: Internal Server Error
      security:
        - bearerAuth: []
components:
  schemas:
    KakaoBrandMessageFreestyleRequest:
      $ref: '#/components/schemas/KakaoBrandMessageFreestyleContent'
    KakaoBrandMessageFreestyleSuccessResponse:
      type: object
      required:
        - success
      properties:
        success:
          type: boolean
          enum:
            - true
          description: >-
            true means the send request has been accepted into the queue. It
            does not confirm successful sending by Kakao.
    KakaoBrandMessageFreestyleErrorResponse:
      type: object
      required:
        - success
        - error
      properties:
        success:
          type: boolean
          enum:
            - false
          description: >-
            false means the send request was rejected or a server error
            occurred.
        error:
          type: string
          description: Reason for the request rejection or server error.
    KakaoBrandMessageFreestyleContent:
      oneOf:
        - title: Text
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - message
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - TEXT
                message:
                  type: string
                  maxLength: 1300
                  description: |
                    Message delivered to the user.

                    - Up to 99 line breaks.
                    - URLs are allowed.
                attachment:
                  type: object
                  description: Content attached to the message
                  properties:
                    button:
                      type: array
                      maxItems: 5
                      description: |
                        Buttons.

                        Up to 4 buttons when a coupon is included.
                      items:
                        $ref: >-
                          #/components/schemas/KakaoBrandMessageFreestyleTextImageButton
                    coupon:
                      $ref: '#/components/schemas/KakaoBrandMessageFreestyleCoupon'
        - title: Image
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - message
                - attachment
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - IMAGE
                message:
                  type: string
                  maxLength: 1300
                  description: |
                    Message delivered to the user.

                    - Up to 99 line breaks.
                    - URLs are allowed.
                attachment:
                  $ref: >-
                    #/components/schemas/KakaoBrandMessageFreestyleImageAttachment
        - title: Wide image
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - message
                - attachment
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - WIDE
                message:
                  type: string
                  maxLength: 76
                  description: |
                    Message delivered to the user.

                    - Up to 5 line breaks.
                attachment:
                  $ref: >-
                    #/components/schemas/KakaoBrandMessageFreestyleWideAttachment
        - title: Wide item list
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - header
                - attachment
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - WIDE_ITEM_LIST
                header:
                  type: string
                  maxLength: 20
                  description: |
                    The `header` field is required.

                    - Line breaks are not allowed.
                attachment:
                  type: object
                  description: Content attached to the message
                  required:
                    - item
                  properties:
                    item:
                      type: object
                      description: Wide list element
                      required:
                        - list
                      properties:
                        list:
                          type: array
                          minItems: 3
                          maxItems: 5
                          description: |
                            Wide list.

                            - `title` is optional for item 1.
                            - `title` is required for items 2 through 5.
                          items:
                            $ref: >-
                              #/components/schemas/KakaoBrandMessageFreestyleWideItem
                    button:
                      type: array
                      maxItems: 2
                      description: Buttons
                      items:
                        $ref: '#/components/schemas/KakaoBrandMessageFreestyleButton'
                    coupon:
                      $ref: >-
                        #/components/schemas/KakaoBrandMessageFreestyleWideOrVideoCoupon
        - title: Carousel feed
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - carousel
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - CAROUSEL_FEED
                carousel:
                  type: object
                  description: Carousel element
                  required:
                    - list
                  properties:
                    list:
                      type: array
                      minItems: 2
                      maxItems: 6
                      description: Carousel list
                      items:
                        $ref: >-
                          #/components/schemas/KakaoBrandMessageFreestyleCarouselFeedItem
                    tail:
                      $ref: >-
                        #/components/schemas/KakaoBrandMessageFreestyleCarouselTail
        - title: Premium video
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - attachment
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - PREMIUM_VIDEO
                header:
                  type: string
                  maxLength: 20
                  description: |
                    The `header` field is optional.

                    - Line breaks are not allowed.
                message:
                  type: string
                  maxLength: 76
                  description: |
                    Message delivered to the user.

                    - Up to 5 line breaks.
                attachment:
                  type: object
                  description: Content attached to the message
                  required:
                    - video
                  properties:
                    video:
                      type: object
                      description: Video element
                      required:
                        - videoUrl
                      properties:
                        videoUrl:
                          type: string
                          format: uri
                          maxLength: 500
                          description: >-
                            `videoUrl` of a video uploaded through the video
                            upload API.
                        thumbnailUrl:
                          type: string
                          format: uri
                          maxLength: 500
                          description: >
                            Video thumbnail image URL registered through the
                            [image upload
                            API](/en/api-reference/upload-kakao-brand-message-image).
                            Defaults to the video's default thumbnail.


                            - `thumbnailUrl` is required if `videoUrl` points to
                            a private video.
                    button:
                      type: array
                      maxItems: 1
                      description: Buttons
                      items:
                        $ref: '#/components/schemas/KakaoBrandMessageFreestyleButton'
                    coupon:
                      $ref: >-
                        #/components/schemas/KakaoBrandMessageFreestyleWideOrVideoCoupon
        - title: Commerce
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - attachment
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - COMMERCE
                additionalContent:
                  type: string
                  maxLength: 34
                  description: |
                    Additional content.

                    - Up to 1 line break.
                attachment:
                  $ref: >-
                    #/components/schemas/KakaoBrandMessageFreestyleCommerceAttachment
        - title: Carousel commerce
          allOf:
            - $ref: '#/components/schemas/KakaoBrandMessageFreestyleRequestCommon'
            - type: object
              required:
                - chatBubbleType
                - carousel
              properties:
                chatBubbleType:
                  type: string
                  description: Message type
                  enum:
                    - CAROUSEL_COMMERCE
                carousel:
                  type: object
                  description: Carousel element
                  required:
                    - list
                  properties:
                    head:
                      $ref: >-
                        #/components/schemas/KakaoBrandMessageFreestyleCarouselHead
                    list:
                      type: array
                      minItems: 1
                      maxItems: 6
                      description: >
                        Carousel list.


                        - At least 2 items are required when `carousel.head` is
                        not used.
                      items:
                        type: object
                        required:
                          - attachment
                        properties:
                          additionalContent:
                            type: string
                            maxLength: 34
                            description: |
                              Additional content for the carousel list.

                              - Up to 1 line break.
                          attachment:
                            description: Image and button information for a carousel item
                            allOf:
                              - $ref: >-
                                  #/components/schemas/KakaoBrandMessageFreestyleCommerceAttachment
                    tail:
                      $ref: >-
                        #/components/schemas/KakaoBrandMessageFreestyleCarouselTail
      discriminator:
        propertyName: chatBubbleType
    KakaoBrandMessageFreestyleRequestCommon:
      type: object
      required:
        - projectId
        - channelId
        - target
        - recipientList
      properties:
        projectId:
          type: string
          description: Project ID shown on the Notifly settings page.
        channelId:
          type: string
          description: >-
            Kakao Channel ID registered as a Kakao Business Message sender in
            the project.
        target:
          type: string
          enum:
            - M
            - 'N'
            - I
          description: >-
            Target audience. `M` means members who have consented to marketing
            messages. `N` means members who have consented to marketing messages
            and are not channel friends. `I` means channel friends. Free-form
            messages do not support `I+N`.
        adult:
          type: boolean
          default: false
          description: Whether the message is for adults only.
        recipientList:
          type: array
          minItems: 1
          maxItems: 1000
          description: >-
            Recipients. All recipients in the same request receive the same
            message content.
          items:
            $ref: '#/components/schemas/KakaoBrandMessageFreestyleRecipient'
    KakaoBrandMessageFreestyleTextImageButton:
      description: >-
        Available and required button parameters for each Kakao Brand Message
        button type.
      allOf:
        - type: object
          required:
            - name
          properties:
            name:
              type: string
              maxLength: 14
              description: Button title
        - $ref: '#/components/schemas/KakaoBrandMessageFreestyleButtonCommon'
    KakaoBrandMessageFreestyleCoupon:
      type: object
      description: >
        Coupon element displayed at the bottom of the message.


        - For a channel coupon URL in the format `alimtalk=coupon://`, either
        `schemeAndroid` or `schemeIos` is required.

        - For a standard coupon that does not use a channel coupon URL,
        `urlMobile` is required.
      required:
        - title
        - description
      allOf:
        - type: object
          properties:
            title:
              $ref: '#/components/schemas/KakaoBrandMessageFreestyleCouponTitle'
            description:
              type: string
              maxLength: 12
              description: Coupon description
        - $ref: '#/components/schemas/KakaoBrandMessageFreestyleCouponLinks'
    KakaoBrandMessageFreestyleImageAttachment:
      type: object
      description: Content attached to the message
      required:
        - image
      properties:
        image:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleImage'
        button:
          type: array
          maxItems: 5
          description: |
            Buttons.

            Up to 4 buttons when a coupon is included.
          items:
            $ref: '#/components/schemas/KakaoBrandMessageFreestyleTextImageButton'
        coupon:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleCoupon'
    KakaoBrandMessageFreestyleWideAttachment:
      type: object
      description: Content attached to the message
      required:
        - image
      properties:
        image:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleImage'
        button:
          type: array
          maxItems: 2
          description: Buttons
          items:
            $ref: '#/components/schemas/KakaoBrandMessageFreestyleButton'
        coupon:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleWideOrVideoCoupon'
    KakaoBrandMessageFreestyleWideItem:
      type: object
      required:
        - imgUrl
        - urlMobile
      properties:
        title:
          type: string
          maxLength: 30
          description: |
            Item title.

            - Item 1 - Up to 25 characters and 1 line break.
            - Items 2 through 5 - Up to 30 characters and 1 line break.
        imgUrl:
          type: string
          format: uri
          description: >-
            Item image URL registered through the [image upload
            API](/en/api-reference/upload-kakao-brand-message-image).
        urlMobile:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a mobile device.
        urlPc:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a PC.
        schemeAndroid:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an Android
            mobile device.
        schemeIos:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an iOS mobile
            device.
    KakaoBrandMessageFreestyleButton:
      description: >-
        Available and required button parameters for each Kakao Brand Message
        button type.
      allOf:
        - type: object
          required:
            - name
          properties:
            name:
              type: string
              maxLength: 8
              description: Button title
        - $ref: '#/components/schemas/KakaoBrandMessageFreestyleButtonCommon'
    KakaoBrandMessageFreestyleWideOrVideoCoupon:
      type: object
      description: >
        Coupon element displayed at the bottom of the message.


        - For a channel coupon URL in the format `alimtalk=coupon://`, either
        `schemeAndroid` or `schemeIos` is required.

        - For a standard coupon that does not use a channel coupon URL,
        `urlMobile` is required.
      required:
        - title
        - description
      allOf:
        - type: object
          properties:
            title:
              $ref: '#/components/schemas/KakaoBrandMessageFreestyleCouponTitle'
            description:
              type: string
              maxLength: 18
              description: Coupon description
        - $ref: '#/components/schemas/KakaoBrandMessageFreestyleCouponLinks'
    KakaoBrandMessageFreestyleCarouselFeedItem:
      type: object
      required:
        - header
        - message
        - attachment
      properties:
        header:
          type: string
          maxLength: 20
          description: |
            Carousel list header.

            - Line breaks are not allowed.
        message:
          type: string
          maxLength: 180
          description: |
            Carousel list message.

            - Up to 10 line breaks.
        attachment:
          type: object
          description: Image and button information for a carousel item
          required:
            - image
            - button
          properties:
            image:
              description: Carousel image
              allOf:
                - $ref: '#/components/schemas/KakaoBrandMessageFreestyleImage'
            button:
              type: array
              minItems: 1
              maxItems: 2
              description: Buttons for the carousel list
              items:
                $ref: '#/components/schemas/KakaoBrandMessageFreestyleButton'
            coupon:
              $ref: '#/components/schemas/KakaoBrandMessageFreestyleCoupon'
    KakaoBrandMessageFreestyleCarouselTail:
      type: object
      description: Show more button
      required:
        - urlMobile
      properties:
        urlMobile:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a mobile device.
        urlPc:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a PC.
        schemeAndroid:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an Android
            mobile device.
        schemeIos:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an iOS mobile
            device.
    KakaoBrandMessageFreestyleCommerceAttachment:
      type: object
      description: Content attached to the message
      required:
        - image
        - commerce
        - button
      properties:
        image:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleImage'
        commerce:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleCommerce'
        button:
          type: array
          minItems: 1
          maxItems: 2
          description: Buttons
          items:
            $ref: '#/components/schemas/KakaoBrandMessageFreestyleButton'
        coupon:
          $ref: '#/components/schemas/KakaoBrandMessageFreestyleCoupon'
    KakaoBrandMessageFreestyleCarouselHead:
      type: object
      description: Carousel intro
      required:
        - header
        - content
        - imageUrl
      properties:
        header:
          type: string
          maxLength: 20
          description: |
            Carousel intro header.

            - Line breaks are not allowed.
        content:
          type: string
          maxLength: 50
          description: |
            Carousel intro content.

            - Up to 2 line breaks.
        imageUrl:
          type: string
          format: uri
          description: >-
            Carousel intro image URL registered through the [image upload
            API](/en/api-reference/upload-kakao-brand-message-image).
        urlMobile:
          type: string
          format: uri
          maxLength: 1000
          description: >
            URL to open when clicked on a mobile device.


            - `urlMobile` is required if any of `urlMobile`, `urlPc`,
            `schemeAndroid`, or `schemeIos` is provided.
        urlPc:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a PC.
        schemeAndroid:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an Android
            mobile device.
        schemeIos:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an iOS mobile
            device.
    KakaoBrandMessageFreestyleRecipient:
      type: object
      required:
        - recipientNo
      properties:
        recipientNo:
          type: string
          description: Recipient mobile phone number.
    KakaoBrandMessageFreestyleButtonCommon:
      type: object
      required:
        - type
      properties:
        type:
          type: string
          enum:
            - WL
            - AL
            - BK
            - MD
            - AC
            - BC
            - BT
            - BF
          description: >
            Button type. All required parameters for the selected type must be
            provided to send the message.


            - `AC` - Adds the KakaoTalk channel when clicked.
                - Appears as a highlighted yellow button. If there are multiple buttons, use the designated position.
                    - `TEXT`, `IMAGE` - First button, at the top.
                    - Other types - Second button, on the right.
                - `name` must be `채널 추가`.
                - Only 1 is allowed across the entire carousel.
                - Available only for targets `M` and `N`.
            - `WL` - Opens the specified web link.
              - `urlMobile` is required.
            - `AL` - Opens the specified app scheme or web link.
              - At least 2 of `schemeAndroid`, `schemeIos`, and `urlMobile` are required.
            - `BK` - Sends the button text.

            - `MD` - Sends the button text and message body.

            - `BC` - Available only for KakaoTalk channels that use SangdamTalk.

            - `BT` - Available only for KakaoTalk channels that use a chatbot
            built with Kakao i Open Builder.

            - `BF` - Opens a Kakao Business Form.
                - Appears as a highlighted yellow button and must use the designated position.
                - Without an `AC` button:
                    - `TEXT`, `IMAGE` - First button, at the top.
                    - Other types - Second button, on the right.
                - With an `AC` button:
                    - `TEXT`, `IMAGE` - Second button, second from the top.
                    - Other types - First button, on the left.
                - `name` must be one of the following:
                    - `톡에서 예약하기`
                    - `톡에서 설문하기`
                    - `톡에서 응모하기`
                - `bizFormKey` is required.
        schemeAndroid:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an Android
            mobile device.
        schemeIos:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an iOS mobile
            device.
        urlMobile:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a mobile device.
        urlPc:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a PC.
        chatExtra:
          type: string
          description: >-
            Metadata passed when switching between SangdamTalk and a KakaoTalk
            chatbot.
        chatEvent:
          type: string
          description: >-
            KakaoTalk chatbot event name to invoke when switching to the
            chatbot.
        bizFormKey:
          type: string
          description: '`bizFormKey` issued when the Business Form is uploaded.'
    KakaoBrandMessageFreestyleCouponTitle:
      type: string
      description: |
        Coupon title.

        Accepted coupon titles:

        - `${숫자}원 할인 쿠폰`, where the number is 1 to 99,999,999.
        - `${숫자}% 할인 쿠폰`, where the number is 1 to 100.
        - `배송비 할인 쿠폰`
        - `${7자 이내} 무료 쿠폰`, with up to 7 characters in the placeholder.
        - `${7자 이내} UP 쿠폰`, with up to 7 characters in the placeholder.
    KakaoBrandMessageFreestyleCouponLinks:
      type: object
      properties:
        urlMobile:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a mobile device.
        urlPc:
          type: string
          format: uri
          maxLength: 1000
          description: URL to open when clicked on a PC.
        schemeAndroid:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an Android
            mobile device.
        schemeIos:
          type: string
          maxLength: 1000
          description: >-
            Custom application scheme to launch when clicked on an iOS mobile
            device.
    KakaoBrandMessageFreestyleImage:
      type: object
      description: Image element
      required:
        - imgUrl
      properties:
        imgUrl:
          type: string
          format: uri
          description: >
            Image URL registered through the [image upload
            API](/en/api-reference/upload-kakao-brand-message-image).


            - All images in `CAROUSEL_COMMERCE` must have the same aspect ratio.
        imgLink:
          type: string
          format: uri
          maxLength: 1000
          description: >-
            URL to open when the image is clicked. If omitted, the image opens
            in the KakaoTalk image viewer.
    KakaoBrandMessageFreestyleCommerce:
      type: object
      description: Commerce element
      required:
        - title
        - regularPrice
      properties:
        title:
          type: string
          maxLength: 30
          description: |
            Product title.

            - Line breaks are not allowed.
        regularPrice:
          type: integer
          minimum: 0
          maximum: 99999999
          description: Regular price
        discountPrice:
          type: integer
          minimum: 0
          maximum: 99999999
          description: Discounted price
        discountRate:
          type: integer
          minimum: 1
          maximum: 100
          description: >
            Discount rate.


            If a discounted price is provided, either `discountRate` or
            `discountFixed` is required.
        discountFixed:
          type: integer
          minimum: 0
          maximum: 999999
          description: >
            Fixed discount amount.


            If a discounted price is provided, either `discountRate` or
            `discountFixed` is required.
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: Pass the token issued by `POST /authenticate` as a bearer token.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.